;;;load "povray.lisp" first

(defpovray knot
  (num color where shape))

(defun example ()
  (let* ((color1 '())
         (color2 '())
         (num 0)
         (shape '())
         (trans '()))
    (loop for i from 0 below 10 do
          (setf color1 (list (random 1.0) (random 1.0) (random 1.0)))
          (setf color2 (list (- 1 (first color1)) (- 1 (second color1)) (- 1 (third color1))))
          (setf num (+ 3 (random 7)))
          (setf shape (append (list 0 '(0 0 0))
                              (loop for i from 1 to num 
                                    collect i 
                                    collect (list (- (random 2.0) 1.0)
                                                  (- (random 1.5) .75)
                                                  (- (random 2.0) 1.0)))
                              (list (+ 1 num) '(0 0 0))))
          (setf trans (list 0 '(0 0 0) 
                            1.9 (list (- (random 2.0) 1.0)
                                      (- (random 1.5) .75)
                                      (- (random 2.0) 1.0))))
          collect
          (make-instance 'knot :instr 'knot :start (* i 2) :end (+ (* i 2) 1.9)
                         :color color1
                         :num num
                         :shape (make-instance 'spline :type 'linear_spline :env shape)
                         :where (make-instance 'spline :env trans))
          collect
          (make-instance 'knot :instr 'snake :start (* i 2) :end (+ (* i 2) 1.9)
                         :color color2
                         :num num
                         :shape (make-instance 'spline :env shape)
                         :where (make-instance 'spline :env trans)))))

(pov-events "(directory) test.pov" (example))